
proc (0)=ar2init(ILEVEL);

/* Note global variables are k,x1,phi,and p1

If ILEVEL = 1, the state contains the level of C(t) as its last
 element.  This element is initialized with an exact prior.

*/

clearg lam, ph1,ph2,lag,k1,k2,i,j,ii;

@ Initialization for KF with AR2 state @

/* -- Initial Conditions -- state is AR(2) */

x1=zeros(k,1);
lam=zeros(k+1,1);            @ Matrix for autocovariances of an AR(2) @
ph1=phi[1,1];
ph2=phi[2,1];
lam[1,1]=q[1,1]/( (1-(ph1^2)-(ph2^2)) - (2*(ph1^2)*ph2/(1-ph2)) );
lam[2,1]=ph1*lam[1,1]/(1-ph2);

k1=k+1; k2=k;
if ilevel .eq 1; k1=k; k2=k-1; endif;

lag=3; do while lag <=k1;
lam[lag,1]=ph1*lam[lag-1,1]+ph2*lam[lag-2,1];
lag=lag+1; endo;

@ Initialize p1 @

i=1; do while i <= k2;
 j=1; do while j <=k2;
   ii=abs(i-j);
   p1[i,j] = lam[ii+1,1];
   j=j+1; endo;
 i=i+1; endo;

if ilevel .eq 1;
 p1[.,k] = zeros(k,1);
 p1[k,.] = zeros(1,k);
 p1[k,k] = 0;              @ exact prior for level @
endif;

retp;
endp;


